#include <thrust/sort.h>
#include <cstdio>

const int N = 6;

int a[N] = {1, 4, 2, 8, 5, 7};

void PRINT( ){
 for(int i = 0; i < N; ++i){
  printf("%d ", a[i]);
 }
 printf("\n");
}

int main(){
 thrust::sort(a, a + N);
 printf("sort a: ");
 PRINT();

 thrust::stable_sort(a, a + N, thrust::greater<int>());
 printf("\nstable_sort a: ");
 PRINT();

 int keys[N] = {1, 4, 2, 8, 5, 7};
 char values[N] = {'a', 'b', 'c', 'd', 'e', 'f'};

 thrust::sort_by_key(keys, keys + N, values);

 printf("\nsort_by_key values: ");
 for(int i = 0; i < N; ++i){
  printf("%c ", values[i]);
 }
 printf("\n");

 return 0;
}
